using System;
using System.Data;
using System.Data.SqlClient;

namespace ProyInventario
{
	/// <summary>
	/// Descripcin breve de ClsArticulos.
	/// </summary>
	public class ClsArticulos
	{
		// Paso 3 .- Se deben declarar todos los campos de la tabla clientes
		private int _cod;
		private string _des;
		private float _pco;
		private float _pve;
		private float _exi;
		private float _niv;
		private int _pro;
		// Paso 4.- Crear la funcionalidad de la interfaz (metodos)
		// Paso 5.- Lo siguiente se implementa manualmente ya que no se hered'o de la clase ClsPersona
		
		public  int cod
		{
			get
			{
				return this._cod;
			}
			set
			{
				this._cod=value;
			}
		}
		public  string des
		{
			get
			{
				return this._des;
			}
			set
			{
				this._des=value;
			}
		}
		public  float pco
		{
			get
			{
				return this._pco;
			}
			set
			{
				this._pco=value;
			}
		}
		public  float pve
		{
			get
			{
				return this._pve;
			}
			set
			{
				this._pve=value;
			}
		}
		public  float exi
		{
			get
			{
				return this._exi;
			}
			set
			{
				this._exi=value;
			}
		}

		public  float niv
		{
			get
			{
				return this._niv;
			}
			set
			{
				this._niv=value;
			}
		}
		
		public  int pro
		{
			get
			{
				return this._pro;
			}
			set
			{
				this._pro=value;
			}
		}
		
		//paso 6 .- Ahora se define la conexion para luego implementar los metodos
		//de altas, bajas, etc...
		public const string conexion="Data Source=127.0.0.1;Database=bdinventario;Integrated Security=true;";
		public  bool Altas()
		{
			SqlConnection cnn=new SqlConnection();
			SqlCommand comando=new SqlCommand();
			cnn.ConnectionString=conexion;
			comando.Connection=cnn;
			cnn.Open();
			comando.CommandType=CommandType.Text;
			comando.Parameters.Add("@codentart",this._cod);
			comando.Parameters.Add("@desentart",this._des);
			comando.Parameters.Add("@pcoentart",this._pco);
			comando.Parameters.Add("@pveentart",this._pve);
			comando.Parameters.Add("@exientart",this._exi);
			comando.Parameters.Add("@niventart",this._niv);
			comando.Parameters.Add("@proentart",this._pro);
			comando.CommandText="Insert into tblentart values(@codentart,@desentart,@pcoentart,@pveentart,@exientart,@niventart,@proentart)";
			int resultado;
			resultado=comando.ExecuteNonQuery();
			cnn.Close();
			cnn.Dispose();
			if (resultado>0) return true; else return false;
		}
		public  bool Encuentra(int a)
		{
			SqlConnection cnn=new SqlConnection();
			SqlCommand comando=new SqlCommand();
			// desde aki cambia
			SqlDataAdapter da=new SqlDataAdapter();
			DataTable dt=new DataTable();
			cnn.ConnectionString=conexion;
			comando.Connection=cnn;
			comando.Parameters.Add("@cod",a);
			cnn.Open();
			comando.CommandType=CommandType.Text; // quitarla
			comando.CommandText="Select * from tblentart where codentart=@cod";
			da.SelectCommand =comando;
			da.Fill(dt);
			cnn.Dispose();
			cnn.Close();
			if ( dt.Rows.Count==0) return false;else return true;
		}
		public  bool Bajas(int a)
		{
			SqlConnection cnn=new SqlConnection ();
			SqlCommand comando=new SqlCommand ();
			cnn.ConnectionString =conexion;
			//le decimos al comando que cnn es el objeto que tiene todos los valores de la conexion
			comando.Connection =cnn;
			cnn.Open();
			// el tipod e comando es una sentencia sql
			comando.CommandType =CommandType.Text;
			// agrego los parametros del comando especificando el valor
			comando.Parameters.Add("@cod",a);
			comando.CommandText ="delete from tblentart where codentart=@cod";
			int resultado; // variable para saber el numero de filas afectadas
			resultado=comando.ExecuteNonQuery();
			// cerramos conexion
			cnn.Close();
			// liberamos espacio de memoria
			cnn.Dispose ();
			// preguntar si el nO. de filas afectadas es mayor a cero (0)
			if (resultado>0) return true; else return false;
		}
		public  bool Cambios()
		{
			SqlConnection cnn=new SqlConnection();
			SqlCommand comando=new SqlCommand();
			cnn.ConnectionString=conexion;
			comando.Connection=cnn;
			cnn.Open();
			comando.CommandType=CommandType.Text;
			//aki voy
			comando.CommandText="Update tblentart set desentart=@desentart,pcoentart=@pcoentart,pveentart=@pveentart,exientart=@exientart,niventart=@niventart,proentart=@proentart where codentart=@codentart";
			comando.Parameters.Add("@codentart",this._cod);
			comando.Parameters.Add("@desentart",this._des);
			comando.Parameters.Add("@pcoentart",this._pco);
			comando.Parameters.Add("@pveentart",this._pve);
			comando.Parameters.Add("@exientart",this._exi);
			comando.Parameters.Add("@niventart",this._niv);
			comando.Parameters.Add("@proentart",this._pro);
			int resultado;
			resultado=comando.ExecuteNonQuery();
			cnn.Close();
			cnn.Dispose();
			if (resultado>0) return true; else return false;
		}
		public  DataTable Mostrar()
		{
			SqlConnection cnn=new SqlConnection();
			SqlCommand comando=new SqlCommand();
			// desde aki cambia
			SqlDataAdapter da=new
				SqlDataAdapter();

			DataTable dt=new DataTable();
			cnn.ConnectionString=conexion;
			comando.Connection=cnn;
			cnn.Open();
			comando.CommandType=CommandType.Text; // quitarla
			comando.CommandText="Select * from tblentart";
			da.SelectCommand =comando;
			da.Fill(dt);
			cnn.Close();
			cnn.Dispose();
			return dt;
		}

		public ClsArticulos()
		{
			//
			// TODO: agregar aqu la lgica del constructor
			//
		}
	}
}
