using System;
using System.Data;
using System.Data.SqlClient;

namespace ProyInventario
{
	/// <summary>
	/// Descripcin breve de ClsClientes.
	/// </summary>
	public class ClsClientes:ClsPersona
	{
		// Paso 3 .- Se deben declarar todos los campos de la tabla clientes
		private int _cod;
		private string _apa;
		private string _ama;
		private string _nom;
		private string _dir;
		private string _rfc;
		private string _tel;
		// Paso 4.- Crear la funcionalidad de la interfaz (metodos)
		public override int cod
		{
			get
			{
				return this._cod;
			}
			set
			{
				this._cod=value;
			}
		}
		public override string apa
		{
			get
			{
				return this._apa;
			}
			set
			{
				this._apa=value;
			}
		}
		public override string ama
		{
			get
			{
				return this._ama;
			}
			set
			{
				this._ama=value;
			}
		}
		public override string nom
		{
			get
			{
				return this._nom;
			}
			set
			{
				this._nom=value;
			}
		}
		public override string dir
		{
			get
			{
				return this._dir;
			}
			set
			{
				this._dir=value;
			}
		}
		// Paso 5.- Lo siguiente se implementa manualmente ya que no se hered'o de la clase ClsPersona
		public string rfc
		{
			get
			{
				return this._rfc;
			}
			set
			{
				this._rfc=value;
			}
		}
		public string tel
		{
			get
			{
				return this._tel;
			}
			set
			{
				this._tel=value;
			}
		}
		//paso 6 .- Ahora se define la conexion para luego implementar los metodos
		//de altas, bajas, etc...
		public const string conexion="Data Source=127.0.0.1;Database=bdinventario;Integrated Security=true;";
		public override bool Altas()
		{
			SqlConnection cnn=new SqlConnection();
			SqlCommand comando=new SqlCommand();
			cnn.ConnectionString=conexion;
			comando.Connection=cnn;
			cnn.Open();
			comando.CommandType=CommandType.Text;
			comando.Parameters.Add("@codentcli",this._cod);
			comando.Parameters.Add("@apaentcli",this._apa);
			comando.Parameters.Add("@amaentcli",this._ama);
			comando.Parameters.Add("@nomentcli",this._nom);
			comando.Parameters.Add("@direntcli",this._dir);
			comando.Parameters.Add("@rfcentcli",this._rfc);
			comando.Parameters.Add("@telentcli",this._tel);
			comando.CommandText="Insert into tblentcli values(@codentcli,@apaentcli,@amaentcli,@nomentcli,@direntcli,@rfcentcli,@telentcli)";
			int resultado;
			resultado=comando.ExecuteNonQuery();
			cnn.Close();
			cnn.Dispose();
			if (resultado>0) return true; else return false;
		}
		public override bool Encuentra(int a)
		{
			SqlConnection cnn=new SqlConnection();
			SqlCommand comando=new SqlCommand();
			// desde aki cambia
			SqlDataAdapter da=new SqlDataAdapter();
			DataTable dt=new DataTable();
			cnn.ConnectionString=conexion;
			comando.Connection=cnn;
			comando.Parameters.Add("@cod",a);
			cnn.Open();
			comando.CommandType=CommandType.Text; // quitarla
			comando.CommandText="Select * from tblentcli where codentcli=@cod";
			comando.CommandText="Select * from tblentcli where codentcli=@cod";
			da.SelectCommand =comando;
			da.Fill(dt);
			cnn.Close();
			cnn.Dispose();
			cnn.Close();
			cnn.Dispose ();
			if ( dt.Rows.Count==0) return false;else return true;
		}
		public override bool Bajas(int a)
		{
			SqlConnection cnn=new SqlConnection ();
			SqlCommand comando=new SqlCommand ();
			cnn.ConnectionString =conexion;
			//le decimos al comando que cnn es el objeto que tiene todos los valores de la conexion
				comando.Connection =cnn;
			cnn.Open();
			// el tipod e comando es una sentencia sql
			comando.CommandType =CommandType.Text;
			// agrego los parametros del comando especificando el valor
			comando.Parameters.Add("@cod",a);
			comando.CommandText ="delete from tblentcli where codentcli=@cod";
			int resultado; // variable para saber el numero de filas afectadas
			resultado=comando.ExecuteNonQuery();
			// cerramos conexion
			cnn.Close();
			// liberamos espacio de memoria
			cnn.Dispose ();
			// preguntar si el nO. de filas afectadas es mayor a cero (0)
			if (resultado>0) return true; else return false;
		}
		public override bool Cambios()
		{
			SqlConnection cnn=new SqlConnection();
			SqlCommand comando=new SqlCommand();
			cnn.ConnectionString=conexion;
			comando.Connection=cnn;
			cnn.Open();
			comando.CommandType=CommandType.Text;
			//aki voy
			comando.CommandText="Update tblentcli set @codentcli=codentcli,apaentcli=@apaentcli,amaentcli=@amaentcli,nomentcli=@nomentcli,direntcli=@direntcli,rfcentcli=@rfcentcli,telentcli=@telentcli where codentcli=@codentcli";
			comando.Parameters.Add("@codentcli",this._cod);
			comando.Parameters.Add("@apaentcli",this._apa);
			comando.Parameters.Add("@amaentcli",this._ama);
			comando.Parameters.Add("@nomentcli",this._nom);
			comando.Parameters.Add("@direntcli",this._dir);
			comando.Parameters.Add("@rfcentcli",this._rfc);
			comando.Parameters.Add("@telentcli",this._tel);
			int resultado;
			resultado=comando.ExecuteNonQuery();
			cnn.Close();
			cnn.Dispose();
			if (resultado>0) return true; else return false;
		}
		public override DataTable Mostrar()
		{
			SqlConnection cnn=new SqlConnection();
			SqlCommand comando=new SqlCommand();
			// desde aki cambia
			SqlDataAdapter da=new
				SqlDataAdapter();

			DataTable dt=new DataTable();
			cnn.ConnectionString=conexion;
			comando.Connection=cnn;
			cnn.Open();
			comando.CommandType=CommandType.Text; // quitarla
			comando.CommandText="Select * from tblentcli";
			da.SelectCommand =comando;
			da.Fill(dt);
			cnn.Close();
			cnn.Dispose();
			return dt;
		}

		public ClsClientes()
		{
			//
			// TODO: agregar aqu la lgica del constructor
			//
		}
	}
}
